unit TZRegistry;

interface

uses
  Registry;

type
  TTZRegistry = class(TRegistry)
  public
    function ReadIntegerDef(const Name : string; const Default : integer) : integer;
    function ReadStringDef(const Name : string; const Default : string) : string;
    function ReadBoolDef(const Name : string; const Default : boolean) : boolean;
  end; {TTZRegistry}

implementation

{ TTZRegistry }

function TTZRegistry.ReadBoolDef(const Name: string;
  const Default: boolean): boolean;
begin
  if ValueExists(Name) then
    Result := ReadBool(Name)
  else
    Result := Default;
end; {ReadBoolDef}

function TTZRegistry.ReadIntegerDef(const Name: string;
  const Default: integer): integer;
begin
  if ValueExists(Name) then
    Result := ReadInteger(Name)
  else
    Result := Default;
end; {ReadIntegerDef}

function TTZRegistry.ReadStringDef(const Name, Default: string): string;
begin
  if ValueExists(Name) then
    Result := ReadString(Name)
  else
    Result := Default;
end; {ReadStringDef}

end.


